/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.core;

import java.util.ArrayList;
import java.util.Collection;

import org.radrails.rails.core.yml.YMLContentHandler;

public class DatabaseContentHandler implements YMLContentHandler {

	private Collection fDescriptors;
	
	private DatabaseDescriptor fCurDescriptor;
	
	public void alias(String name) {
		// TODO figure out how to deal with aliases
		
	}

	public void endDocument() {
		if(fCurDescriptor != null && !fDescriptors.contains(fCurDescriptor)) {
			fDescriptors.add(fCurDescriptor);
		}
	}

	public void mapping(String key, String value) {
		if(fCurDescriptor == null) {
			return;
		}
		
		if(key.equals("adapter")) {
			fCurDescriptor.setAdapter(value);
		}
		else if(key.equals("database")) {
			fCurDescriptor.setDatabase(value);
		}
		else if(key.equals("host")) {
			fCurDescriptor.setHost(value);
		}
		else if(key.equals("username")) {
			fCurDescriptor.setUsername(value);
		}
		else if(key.equals("password")) {
			fCurDescriptor.setPassword(value);
		}
		else if(key.equals("port")) {
			fCurDescriptor.setPort(value);
		}
		else if(key.equals("sslcert")) {
			fCurDescriptor.setSSLCert(value);
		}
		else if(key.equals("sslcapath")) {
			fCurDescriptor.setSSLCapath(value);
		}
		else if(key.equals("sslcipher")) {
			fCurDescriptor.setSSLCipher(value);
		}
		else if(key.equals("socket")) {
			fCurDescriptor.setSocket(value);
		}
		else if(key.equals("sslkey")) {
			fCurDescriptor.setSSLKey(value);
		}
		else if(key.equals("schema_order")) {
			fCurDescriptor.setSchemaOrder(value);
		}
		else if(key.equals("dbfile")) {
			fCurDescriptor.setDBFile(value);
		}
	}

	public void node(String name) {
		if(fCurDescriptor != null) {
			fDescriptors.add(fCurDescriptor);
		}
		fCurDescriptor = new DatabaseDescriptor(name);
	}

	public void startDocument() {
		// TODO Auto-generated method stub
		fDescriptors = new ArrayList();
	}
	
	public Collection getDescriptors() {
		return fDescriptors;
	}

}
