/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.core;

import java.io.IOException;
import java.io.Reader;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.radrails.rails.core.yml.YMLParser;
import org.radrails.rails.core.yml.YMLParserException;
import org.radrails.rails.core.yml.YMLParserFactory;

public class DatabaseYml {

	private Map fDescriptors;
	
	public DatabaseYml() {
		fDescriptors = new HashMap();
	}
	
//	private Collection fListeners;
//	
//	public void addListener(IDatabaseYmlChangeListener listener) {
//		fListeners.add(listener);
//	}
//	
//	public void removeListener(IDatabaseYmlChangeListener listener) {
//		fListeners.remove(listener);
//	}
//	
//	private void fireChanged() {
//		Iterator i = fListeners.iterator();
//		while(i.hasNext()) {
//			IDatabaseYmlChangeListener listener = (IDatabaseYmlChangeListener) i.next();
//			listener.databaseYmlChanged(this);
//		}
//	}
	
	public DatabaseDescriptor getDescriptor(String name) {
		return (DatabaseDescriptor) fDescriptors.get(name);
	}
	
	public Collection getDescriptors() {
		return fDescriptors.values();
	}
	
	public void load(Reader reader) {
		YMLParser parser = YMLParserFactory.newParser();
		DatabaseContentHandler handler = new DatabaseContentHandler();
		parser.setContentHandler(handler);
		try {
			parser.parse(reader);
			Iterator i = handler.getDescriptors().iterator();
			while(i.hasNext()) {
				DatabaseDescriptor dd = (DatabaseDescriptor) i.next();
				fDescriptors.put(dd.getName(), dd);
			}
//			fireChanged();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (YMLParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
}
