/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.core.sqlite;

import java.sql.Connection;
import java.sql.SQLException;

import org.radrails.db.core.DatabaseConnection;
import org.radrails.db.core.DatabaseConnector;
import org.radrails.db.core.DatabaseDescriptor;

import SQLite.JDBCDriver;

/**
 * Verifies a connection can be made with the database.
 * 
 * @author mbaumbach
 * 
 * @version 0.2.0
 */
public class SQLiteDatabaseConnection extends DatabaseConnection {

	public static final String SQLITE_DBFILE = "db/test";

	public static final String SQLITE_DEFAULT_PORT = "";

	public static final String JDBC_SQLITE_URL = "jdbc:sqlite:/";

	public static final String CONNECTION_URL = JDBC_SQLITE_URL
			+ SQLITE_DBFILE;

	/**
	 * @see org.radrails.db.core.DatabaseConnection#getDefaultPort()
	 */
	public String getDefaultPort() {
		return SQLiteDatabaseConnection.SQLITE_DEFAULT_PORT;
	}

	/**
	 * @see org.radrails.db.core.DatabaseConnection#connect(org.radrails.db.core.DatabaseDescriptor)
	 */
	public Connection connect(DatabaseDescriptor desc) throws SQLException,
			InstantiationException, IllegalAccessException {
		String username = desc.getUsername();
		String password = desc.getPassword();
		Class driver = JDBCDriver.class;
		String url = JDBC_SQLITE_URL + desc.getDBFile();
		return DatabaseConnector.getInstance().getConnection(driver, url,
				username, password);
	}

} // MySQLDatabaseConnection
