/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui;

/**
 * Represents a Column in the DataNavigator.
 * 
 * @author	Kyle
 *
 * @version	0.3.1
 */
public class Column implements IDatabaseElement {

	private String name;
	private Table table;
	private boolean isPrimaryKey;
	private boolean isForeignKey;
	
	/**
	 * Creates a new Column.
	 * 
	 * @param	columnName	The name of the column.
	 * @param	table	The table to this column belongs in.
	 */
	public Column(String columnName, Table table, boolean isPrimaryKey, boolean isForeignKey){
		this.name = columnName;
		this.table = table;
		this.isPrimaryKey = isPrimaryKey;
		this.isForeignKey = isForeignKey;
	}

	/**
	 * @see org.radrails.db.internal.ui.IDatabaseElement#getParent()
	 */
	public IDatabaseElement getParent() {
		return table;
	}

	/**
	 * @see org.radrails.db.internal.ui.IDatabaseElement#getName()
	 */
	public String getName() {
		return name;
	}
	
	public boolean isPrimaryKey() {
		return isPrimaryKey;
	}
	
	public boolean isForeignKey() {
		return isForeignKey;
	}

	/**
	 * @see org.radrails.db.internal.ui.IDatabaseElement#getChildren()
	 */
	public Object[] getChildren() {
		return null;
	}

	/**
	 * @see org.radrails.db.internal.ui.IDatabaseElement#hasChildren()
	 */
	public boolean hasChildren() {
		return false;
	}

} // Column