/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;

/**
 * @author Marc
 *
 */
public class DataEditorInput implements IEditorInput {

	private String query;
	private Database database;
	
	/**
	 * Creates a new DataEditorInput object.
	 * 
	 * @param	query	The query displayed by this editor input.
	 * @param	database	The database the query is executed in.
	 */
	public DataEditorInput(String query, Database database){
		this.query = query;
		this.database = database;
	}
	
	/**
	 * @see org.eclipse.ui.IEditorInput#exists()
	 */
	public boolean exists() {
		return false;
	}

	/**
	 * @see org.eclipse.ui.IEditorInput#getImageDescriptor()
	 */
	public ImageDescriptor getImageDescriptor() {
		return null;
	}

	/**
	 * @see org.eclipse.ui.IEditorInput#getName()
	 */
	public String getName() {
		return "Result";
	}

	/**
	 * @see org.eclipse.ui.IEditorInput#getPersistable()
	 */
	public IPersistableElement getPersistable() {
		return null;
	}

	/**
	 * @see org.eclipse.ui.IEditorInput#getToolTipText()
	 */
	public String getToolTipText() {
		return "";
	}

	/**
	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
	 */
	public Object getAdapter(Class adapter) {
		return null;
	}
	
	/**
	 * Gets the query used.
	 * 
	 * @return	The query represented as a String.
	 */
	public String getQuery(){
		return query;
	}
	
	/**
	 * Gets the database for this editor input.
	 * 
	 * @return	The Database that this editor input uses.
	 */
	public Database getDatabase(){
		return database;
	}

} // DataEditorInput