/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

/**
 * The factory that creates the Data Perspective.
 *
 * @author	mbaumbach
 *
 * @version	0.3.1
 */
public class DataPerspectiveFactory implements IPerspectiveFactory {

	/**
	 * @see org.eclipse.ui.IPerspectiveFactory#createInitialLayout(org.eclipse.ui.IPageLayout)
	 */
	public void createInitialLayout(IPageLayout layout) {
		// Get the editor area.
		String editorArea = layout.getEditorArea();
		// Top left: Resource Navigator view and Bookmarks view placeholder
		IFolderLayout topLeft = layout.createFolder("topLeft",
				IPageLayout.LEFT, 0.25f, editorArea);
		topLeft.addView("org.radrails.db.ui.DataNavigator");
		topLeft.addView("org.radrails.rails.ui.ViewRailsNavigator");
		
		// Top: Query view
		IFolderLayout top = layout.createFolder("top",
				IPageLayout.TOP, 0.14f, editorArea);
		top.addView("org.radrails.db.ui.QueryView");
	}

} // DataPerspectiveFactory