/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui;

public interface IDatabaseElement {

	/**
	 * Gets the name of the element.
	 * 
	 * @return	The name of the element.
	 */
	public String getName();
	
	/**
	 * Gets the parent of this element.
	 * 
	 * @return	The IDatabaseElement that contains this element.
	 */
	public IDatabaseElement getParent();
	
	/**
	 * Gets all of the children of this element.
	 * 
	 * @return	An Object[] of the children belonging to this element.
	 */
	public Object[] getChildren();
	
	/**
	 * Checks if this object has any children.
	 * 
	 * @return	<code>true</code> if this element has children,
	 * 			<code>false</code> otherwise.
	 */
	public boolean hasChildren();
	
} // IDatabaseElement