/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui.editors.dbtable;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IPersistableElement;
import org.radrails.db.internal.ui.Database;

/**
 * @author mkent
 *
 */
public class DbTableEditorInput implements IEditorInput {

	private String fTableName;
	
	private Database fDatabase;
	
	public DbTableEditorInput(String tableName, Database db) {
		fTableName = tableName;
		fDatabase = db;
	}
	
	public String getTableName() {
		return fTableName;
	}
	
	public Database getDatabase() {
		return fDatabase;
	}
	
	public boolean exists() {
		return false;
	}

	public ImageDescriptor getImageDescriptor() {
		return null;
	}

	public String getName() {
		return fTableName;
	}

	public IPersistableElement getPersistable() {
		return null;
	}

	public String getToolTipText() {
		return "";
	}

	public Object getAdapter(Class adapter) {
		return null;
	}

}
