package org.radrails.db.internal.ui.editors.dbtable;

import java.util.Iterator;

public class DbTableQueryHelper {

	public static String insertRow(String table, Row r) throws Exception {
		StringBuffer query = new StringBuffer();
		query.append("INSERT INTO ");
		query.append(table);
		StringBuffer cols = new StringBuffer();
		cols.append("(");
		StringBuffer vals = new StringBuffer();
		vals.append("VALUES (");

		Iterator i = r.getNonPkFields().iterator();
		while (i.hasNext()) {
			Field f = (Field) i.next();

			cols.append(f.getColumnName());
			if (i.hasNext()) {
				cols.append(", ");
			}
			if (f.getCurrentValue() instanceof String) {
				vals.append("'" + f.getCurrentValue().toString() + "'");
			} else {
				vals.append(f.getCurrentValue());
			}
			if (i.hasNext()) {
				vals.append(", ");
			}
		}
		cols.append(")");
		vals.append(")");

		query.append(" ");
		query.append(cols.toString());
		query.append(" ");
		query.append(vals.toString());

		System.out.println(query.toString());
		return query.toString();
	}

	public static String deleteRow(String table, Row r) throws Exception {
		StringBuffer query = new StringBuffer();
		query.append("DELETE FROM ");
		query.append(table);
		query.append(" WHERE ");

		Iterator i = r.getPkFields().iterator();
		while (i.hasNext()) {
			Field f = (Field) i.next();

			query.append(f.getColumnName());
			query.append("=");
			if (f.getCurrentValue() instanceof String) {
				query.append("'" + f.getCurrentValue().toString() + "'");
			} else {
				query.append(f.getCurrentValue());
			}
			if (i.hasNext()) {
				query.append(" and ");
			}
		}

		System.out.println(query.toString());
		return query.toString();
	}

	public static String updateRow(String table, Row r) throws Exception {
		StringBuffer query = new StringBuffer();
		query.append("UPDATE ");
		query.append(table);
		query.append(" SET ");

		Iterator j = r.getNonPkFields().iterator();
		while (j.hasNext()) {
			Field f = (Field) j.next();

			query.append(f.getColumnName());
			query.append("=");
			if (f.getCurrentValue() instanceof String) {
				query.append("'" + f.getCurrentValue().toString() + "'");
			} else {
				query.append(f.getCurrentValue());
			}
			if (j.hasNext()) {
				query.append(", ");
			}
		}

		query.append(" WHERE ");

		Iterator i = r.getPkFields().iterator();
		while (i.hasNext()) {
			Field f = (Field) i.next();

			query.append(f.getColumnName());
			query.append("=");
			if (f.getCurrentValue() instanceof String) {
				query.append("'" + f.getCurrentValue().toString() + "'");
			} else {
				query.append(f.getCurrentValue());
			}
			if (i.hasNext()) {
				query.append(" and ");
			}
		}

		System.out.println(query.toString());
		return query.toString();
	}
}
