/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui.editors.dbtable;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * @author mkent
 *
 */
public class Row {

	private DbTableContentModel fParent;
	
	// does the row exist in the database yet?
	private boolean fIsNewRow;
	
	private ArrayList fields;
	
	public Row(DbTableContentModel parent, boolean isNewRow) {
		fParent = parent;
		fIsNewRow = isNewRow;
		fields = new ArrayList();
	}
	
	public void addField(Field f) {
		fields.add(f);
	}
	
	public Collection getFields() {
		return fields;
	}
	
	public Collection getPkFields() {
		Collection pkf = new ArrayList();
		Iterator i = fields.iterator();
		while(i.hasNext()) {
			Field f = (Field) i.next();
			if(f.isPk()) {
				pkf.add(f);
			}
		}
		return pkf;
	}
	
	public Collection getNonPkFields() {
		Collection npkf = new ArrayList();
		Iterator i = fields.iterator();
		while(i.hasNext()) {
			Field f = (Field) i.next();
			if(!f.isPk()) {
				npkf.add(f);
			}
		}
		return npkf;
	}
	
	public Field getField(int columnNum) {
		Field f = null;
		if(fields.size() > columnNum) {
			f = (Field) fields.get(columnNum);
		}
		return f;
	}
	
	public Field getField(String columnName) {
		Field fld = null;
		Iterator i = fields.iterator();
		boolean found = false;
		while(i.hasNext() && !found) {
			Field f = (Field) i.next();
			if(f.getColumnName().equals(columnName)) {
				found = true;
				fld = f;
			}
		}
		return fld;
	}
	
	public boolean isNewRow() {
		return fIsNewRow;
	}
	
	public void rowUpdated() {
		fParent.rowUpdated(this);
	}

}
