/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui.editors.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.radrails.db.internal.ui.DbUIPlugin;
import org.radrails.db.internal.ui.editors.sql.ISqlEditorColorConstants;
import org.radrails.rails.internal.ui.preferences.SourceEditorPreferencePage;

/**
 * Preference page for the SQL editor.
 * 
 * @author	mbaumbach
 * 
 * @version	0.5.3
 */
public class SQLEditorPreferencePage extends SourceEditorPreferencePage {

	/**
	 * Constructor.
	 */
	public SQLEditorPreferencePage() {
		setPreferenceStore(DbUIPlugin.getInstance().getPreferenceStore());
		setDescription("SQL editor preferences");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	protected void createFieldEditors() {
		Composite parent = getFieldEditorParent();
		parent.setLayout(new GridLayout());
		
		createSyntaxEditor(parent, ISqlEditorColorConstants.KEYWORD, "Keyword");
		createSyntaxEditor(parent, ISqlEditorColorConstants.TYPE, "Type");
		createSyntaxEditor(parent, ISqlEditorColorConstants.STRING, "String");
		createSyntaxEditor(parent, ISqlEditorColorConstants.SINGLELINE_COMMENT, "Single-line comment");
		createSyntaxEditor(parent, ISqlEditorColorConstants.MULTILINE_COMMENT, "Multi-line comment");
		
		addField(new StringFieldEditor(IPreferenceConstants.SQL_INDENTATION, "Character(s) per indentation level", 3, getFieldEditorParent()));
		addField(new BooleanFieldEditor(IPreferenceConstants.SQL_FORMAT_USE_TAB, "Use Tabs", getFieldEditorParent()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
		// Do nothing
	}

} // CSSEditorPreferencePage