/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.db.internal.ui.editors.sql.templates;

import org.eclipse.jface.text.templates.GlobalTemplateVariables;
import org.eclipse.jface.text.templates.TemplateContextType;

/**
 * Simple SQL file context type.
 *
 * @author	mbaumbach
 *
 * @version	0.4.1
 */
public class SQLFileContextType extends TemplateContextType {

	/** This context's id */
	public static final String SQLFILE_CONTEXT_TYPE= "org.radrails.db.ui.templateContextType.sqlFile"; //$NON-NLS-1$

	/**
	 * Creates a new Ruby context type. 
	 */
	public SQLFileContextType() {
		addGlobalResolvers();
	}

	/**
	 * Adds the global resolvers.
	 */
	private void addGlobalResolvers() {
		addResolver(new GlobalTemplateVariables.Cursor());
		addResolver(new GlobalTemplateVariables.WordSelection());
		addResolver(new GlobalTemplateVariables.LineSelection());
		addResolver(new GlobalTemplateVariables.Dollar());
		addResolver(new GlobalTemplateVariables.Date());
		addResolver(new GlobalTemplateVariables.Year());
		addResolver(new GlobalTemplateVariables.Time());
		addResolver(new GlobalTemplateVariables.User());
	}
	
} // SQLFileContextType
