/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.core.gems;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

/**
 * Content handler for the rails gems config file. Builds a list of
 * Gem objects and provides accessors for the data it receives.
 * 
 * @author mkent
 * @deprecated
 * 
 */
public class GemsContentHandler implements ContentHandler {

	private Collection gems;

	private Gem selectedGem;

	private Gem currentGem;

	private StringBuffer currentData;

	public void endDocument() throws SAXException {
		// Do nothing
	}

	public void startDocument() throws SAXException {
		gems = new ArrayList();
	}

	public void characters(char[] ch, int start, int length)
			throws SAXException {
		for(int i = start; i < start + length; i++) {
			currentData.append(ch[i]);
		}
	}

	public void ignorableWhitespace(char[] ch, int start, int length)
			throws SAXException {
		// Do nothing
	}

	public void endPrefixMapping(String prefix) throws SAXException {
		// Do nothing
	}

	public void skippedEntity(String name) throws SAXException {
		// Do nothing
	}

	public void setDocumentLocator(Locator locator) {
		// Do nothing
	}

	public void processingInstruction(String target, String data)
			throws SAXException {
		// Do nothing
	}

	public void startPrefixMapping(String prefix, String uri)
			throws SAXException {
		// Do nothing
	}

	public void endElement(String namespaceURI, String localName, String qName)
			throws SAXException {
		if (qName.equals("name")) {
			currentGem.setName(currentData.toString());
		} else if (qName.equals("location")) {
			IPath loc = new Path(currentData.toString());
			currentGem.setLocation(loc);
		} else if (qName.equals("selected")
				&& currentData.toString().equals("true")) {
			selectedGem = currentGem;
		} else if (qName.equals("gem")) {
			gems.add(currentGem);
		}
	}

	public void startElement(String namespaceURI, String localName,
			String qName, Attributes atts) throws SAXException {
		if (qName.equals("gem")) {
			currentGem = new Gem();
		}
		currentData = new StringBuffer();
	}

	public Collection getGems() {
		return gems;
	}

	public Gem getSelectedGem() {
		return selectedGem;
	}

}
