/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/
package org.radrails.rails.core.yml;

import java.io.IOException;
import java.io.Reader;

/**
 * Parses a YML document and notifies the given content handler of content
 * elements.
 * 
 * @author mkent
 * 
 */
public interface YMLParser {

	/**
	 * Set the content handler to use.
	 * 
	 * @param handler
	 *            the content handler
	 */
	public void setContentHandler(YMLContentHandler handler);

	/**
	 * Parse the document.
	 * 
	 * @param input
	 *            the input source for the document
	 * @throws IOException
	 * @throws YMLParserException
	 */
	public void parse(Reader input) throws IOException, YMLParserException;
}
