/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.generators;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * This class locates the installed generators from the rails system environment
 * and the user's home directory.
 * 
 * @author agianfagna
 * 
 */
public class EnvironmentGeneratorLocator extends GeneratorsLocator {
	
//	// {Dir.user_home}/.rails/generators")
//	// File.dirname(__FILE__)}/generators/components"
	
//	public EnvironmentGeneratorLocator( ) {
//		super();
//	}

public void locateGenerators() {
	
	// TODO Just temporary, we need to actually locate the gens.
	Map builtinGenerators = new HashMap();
	
	generators.clear();
	
	builtinGenerators.put("/controller_generator.rb", "ControllerName [action, ...]");
	builtinGenerators.put("/mailer_generator.rb", "MailerName [view, ...]");
	builtinGenerators.put("/migration_generator.rb", "MigrationName");
	builtinGenerators.put("/model_generator.rb", "ModelName");
	builtinGenerators.put("/plugin_generator.rb", "PluginName");
	builtinGenerators.put("/scaffold_generator.rb",
			"ModelName [ControllerName] [action, ...]");
	builtinGenerators.put("/web_service_generator.rb", "WebServiceName [method, ...]");
	builtinGenerators.put("/integration_test_generator.rb",  "IntegrationTestName");
	builtinGenerators.put("/session_migration_generator.rb",  "SessionMigrationName");
	
	Iterator keysIt = builtinGenerators.keySet().iterator();
	while( keysIt.hasNext() ) {
		Generator gen = new Generator( keysIt.next().toString()   );
		generators.add( gen );
	}

}
	

}
