/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.autotest;

import java.util.Iterator;
import java.util.List;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.radrails.rails.internal.ui.RailsUILog;
import org.radrails.rails.ui.test.TestLauncher;
import org.rubypeople.rdt.internal.launching.RubyLaunchConfigurationAttribute;

/**
 * Test launcher for autotest.
 * 
 * @author mkent
 * @deprecated
 * 
 */
public class AutoTestLauncher extends TestLauncher {
	
	public void goLaunch(IProject project, String mode, String testFile, List tests) {
		try {
			fProject = project;
			doLaunch(mode, testFile, tests);
		} catch (CoreException e) {
			RailsUILog.logError("Error launching tests", e);
		}
	}

	protected void doLaunch(String mode, String testFile, List tests) throws CoreException {
		ILaunchConfiguration config = createConfiguration(testFile, tests);
		if (config != null) {
			config.launch(mode, null);
		}
	}
	
	/**
	 * Add the tests to run to the launch configuration.
	 * 
	 * @param testFile
	 *            the autotest launcher
	 * @param tests
	 *            the tests to run
	 * @return a proper launch configuration
	 */
	protected ILaunchConfiguration createConfiguration(String testFile,
			List tests) {
		ILaunchConfiguration config = super.createConfiguration(testFile);
		try {
			ILaunchConfigurationWorkingCopy wcConfig = config.getWorkingCopy();

			StringBuffer stBuf = new StringBuffer();
			Iterator i = tests.iterator();
			while (i.hasNext()) {
				String st = (String) i.next();
				stBuf.append(st);
				if (i.hasNext()) {
					stBuf.append(" ");
				}
			}

			wcConfig.setAttribute(
					RubyLaunchConfigurationAttribute.PROGRAM_ARGUMENTS, stBuf
							.toString());
			config = wcConfig.doSave();
		} catch (CoreException e) {
			RailsUILog.logError(
					"Error retrieving launch configuration working copy", e);
		}

		return config;
	}

}
