/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.autotest;

import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.ToolBarContributionItem;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

/**
 * Toolbar action to toggle autotest activation on and off.
 * 
 * @author mkent
 * @deprecated enablement is now done implicitly according to preferences
 * 
 */
public class EnableAutotestActionDelegate implements
		IWorkbenchWindowActionDelegate {

	public void dispose() {

	}

	public void init(IWorkbenchWindow window) {
		if (AutotestHelper.isAutotestEnabled()) {
			IAction action = getAction(window);
			if(action != null) {
				action.setChecked(true);
			}
		}
	}

	private IAction getAction(IWorkbenchWindow window) {
		IAction action = null;
		ApplicationWindow aw = (ApplicationWindow) window;

		ToolBarContributionItem tbcItem = (ToolBarContributionItem) aw
				.getCoolBarManager().find("org.radrails.rails.ui.railsActions");
		ActionContributionItem acItem = (ActionContributionItem) tbcItem
				.getToolBarManager().find(
						"org.radrails.rails.ui.test.EnableAutotest");
		if (acItem != null) {
			action = acItem.getAction();
		}

		return action;
	}

	public void run(IAction action) {
		if (action.isChecked()) {
			AutotestHelper.enableAutotest();
			action.setToolTipText("Disable Autotest");
		} else {
			AutotestHelper.disableAutotest();
			action.setToolTipText("Enable Autotest");
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {

	}

}
