/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.editors.text.EditorsUI;
import org.eclipse.ui.texteditor.ChainedPreferenceStore;
import org.radrails.rails.internal.ui.RailsUIPlugin;

/**
 * Abstract default token scanner. Scans a region of text and returns a single
 * default token.
 * 
 * @author mkent
 * 
 */
public abstract class AbstractDefaultScanner extends AbstractManagedRuleBasedScanner {

	protected AbstractDefaultScanner() {
		super();
		setDefaultReturnToken(getToken(getColorKeys()[0]));
	}

	protected IPreferenceStore getPreferenceStore() {
		IPreferenceStore[] prefStores = new IPreferenceStore[2];
		prefStores[0] = RailsUIPlugin.getInstance().getPreferenceStore();
		prefStores[1] = EditorsUI.getPreferenceStore();
		return new ChainedPreferenceStore(prefStores);
	}

}
