/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.css;

import org.eclipse.core.filebuffers.IDocumentSetupParticipant;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentExtension3;
import org.eclipse.jface.text.IDocumentPartitioner;
import org.eclipse.jface.text.rules.FastPartitioner;

/**
 * Sets up the partitioner for the CSSEditor.
 * 
 * @author	mbaumbach
 *
 * @version	0.4.1
 */
public class CSSDocumentSetupParticipant implements IDocumentSetupParticipant {

	/**
	 * @see org.eclipse.core.filebuffers.IDocumentSetupParticipant#setup(org.eclipse.jface.text.IDocument)
	 */
	public void setup(IDocument document) {
		if (document instanceof IDocumentExtension3) {
			IDocumentExtension3 extension3 = (IDocumentExtension3) document;
			IDocumentPartitioner partitioner = new FastPartitioner(
					CSSPartitionScanner.getInstance(),
					CSSPartitionScanner.CSS_PARTITION_TYPES);
			extension3.setDocumentPartitioner(CSSEditor.CSS_PARTITIONING,
					partitioner);
			partitioner.connect(document);
		}
	}

} // CSSDocumentSetupParticipant