/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.css;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Gets a reference to the message bundle.
 * 
 * @author	mbaumbach
 *
 * @version	0.4.1
 */
public class CSSEditorMessages {

	private static final String RESOURCE_BUNDLE= "org.radrails.rails.internal.ui.editors.css.CSSEditorMessages";//$NON-NLS-1$

	private static ResourceBundle fgResourceBundle= ResourceBundle.getBundle(RESOURCE_BUNDLE);

	/**
	 * Private constructor since this class does not require an instance.
	 */
	private CSSEditorMessages() {}

	/**
	 * Gets the string of a key.
	 * 
	 * @param	key	The key to look for in the resourcebundle.
	 * 
	 * @return	The corresponding string value for the key.
	 */
	public static String getString(String key) {
		try {
			return fgResourceBundle.getString(key);
		} catch (MissingResourceException e) {
			return "!" + key + "!";//$NON-NLS-2$ //$NON-NLS-1$
		}
	}
	
	/**
	 * Gets the resource bundle for the CSSEditor.
	 * 
	 * @return	The resource bundle.
	 */
	public static ResourceBundle getResourceBundle() {
		return fgResourceBundle;
	}
	
} // CSSEditorMessages