/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.css;

import java.util.regex.Pattern;

import org.eclipse.jface.text.rules.IWordDetector;

/**
 * Word detector for CSS keywords. Uses regular expressions. CSS keywords can
 * start with any word character, and can contain any word character or a
 * '-' character.
 * 
 * @author	mbaumbach
 * 
 * @version	0.4.1
 */
public class CSSWordDetector implements IWordDetector {

	/**
	 * @see org.eclipse.jface.text.rules.IWordDetector#isWordStart(char)
	 */
	public boolean isWordStart(char c) {
		return Pattern.matches("\\w", String.valueOf(c));
	}

	/**
	 * @see org.eclipse.jface.text.rules.IWordDetector#isWordPart(char)
	 */
	public boolean isWordPart(char c) {
		return Pattern.matches("\\w|-", String.valueOf(c));
	}

} // CSSWordDetector