/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.js;

/**
 * Constants for the Javascript editor.
 * 
 * @author mbaumbach
 * 
 * @version 0.5.0
 */
public interface IJavascriptConstants {

	public static final String[] JS_OBJECTS = { "clientInformation",
			"clipboardData", "document", "event", "external", "history",
			"location", "navigator", "screen", "anchor", "applet", "area",
			"base", "basefront", "form", "frame", "frameset", "iframe",
			"image", "link", "meta", "object", "select", "style", "table",
			"tableData", "tableHeader", "tableRow", "textarea", "button",
			"checkbox", "file", "hidden", "password", "radio", "reset",
			"submit", "text", "window" };

	public static final String[] JS_METHODS = { "concat", "join", "pop",
			"push", "reverse", "shift", "slice", "sort", "splice", "toSource",
			"toString", "unshift", "valueOf", "Date", "getDate", "getDay",
			"getMonth", "getFullYear", "getYear", "getHours", "getMinutes",
			"getSeconds", "getMilliseconds", "getTime", "getTimezoneOffset",
			"getUTCDate", "getUTCDay", "getUTCMonth", "getUTCFullYear",
			"getUTCHours", "getUTCMinutes", "getUTCSeconds",
			"getUTCMilliseconds", "parse", "setDate", "setMonth",
			"setFullYear", "setYear", "setHours", "setMinutes", "setSeconds",
			"setMilliseconds", "setTime", "setUTCDate", "setUTCMonth",
			"setUTCFullYear", "setUTCHours", "setUTCMinutes", "setUTCSeconds",
			"setUTCMilliseconds", "toGMTString", "toUTCString",
			"toLocaleString", "UTC", "abs", "acos", "asin", "atan", "atan2",
			"ceil", "cos", "exp", "floor", "log", "max", "min", "pow",
			"random", "round", "sin", "sqrt", "tan", "anchor", "big", "blink",
			"bold", "charAt", "charCodeAt", "fixed", "fontcolor", "fontsize",
			"fromCharCode", "indexOf", "italics", "lastIndexOf", "link",
			"match", "replace", "search", "slice", "small", "split", "strike",
			"sub", "substr", "substring", "sup", "toLowerCase", "toUpperCase",
			"encodeURI", "decodeURIComponent", "encodeURI",
			"encodeURIComponent", "escape", "eval", "isFinite", "isNaN",
			"Number", "parseFloat", "parseInt", "String", "unescape", "blur",
			"focus", "clear", "close", "createAttribute", "createElement",
			"createTextNode", "focus", "getElementById", "getElementsByName",
			"getElementsByTagName", "open", "write", "writeln" };

	public static final String[] JS_PROPERTIES = { "constructor", "index",
			"input", "length", "prototype", "E", "LN2", "LN10", "LOG2E",
			"LOG10E", "PI", "SQRT1_2", "SQRT2", "Infinity", "NaN", "undefined",
			"accessKey", "charset", "coords", "href", "hreflang", "id",
			"innerHTML", "name", "rel", "rev", "shape", "tabIndex", "target",
			"type", "alt", "hash", "host", "hostname", "href", "noHref",
			"pathname", "port", "protocol", "search", "aLink", "background",
			"bgColor", "link", "scrollLeft", "scrollTop", "text", "vLink",
			"alinkColor", "bgColor", "body", "cookie", "documentElement",
			"domain", "fgColor", "lastModified", "linkColor", "referrer",
			"title", "URL", "vlinkColor", "Abstract", "altKey", "altLeft",
			"banner", "button", "cancelBubble", "clientX", "clientY",
			"contentOverflow", "ctrlKey", "ctrlLeft", "dataFld", "fromElement",
			"keyCode", "MoreInfo", "nextPage", "offsetX", "offsetY",
			"propertyName", "qualifier", "reason", "recordset", "repeat",
			"returnValue", "saveType", "screenX", "screenY", "shiftKey",
			"shiftLeft", "srcElement", "srcFilter", "srcUrn", "toElement",
			"userName", "wheelDelta", "x", "y" };

	public static final String[] JS_EVENTS = { "onabort", "onblur", "onchange",
			"onclick", "ondblclick", "onerror", "onfocus", "onkeydown",
			"onkeypress", "onkeyup", "onload", "onmousedown", "onmousemove",
			"onmouseout", "onmouseover", "onmouseup", "onreset", "onresize",
			"onselect", "onsubmit", "onunload", "onBlur", "onFocus", "onClick",
			"onDblClick", "onKeyDown", "onKeyPress", "onKeyUp", "onMouseDown",
			"onMouseMove", "onMouseOut", "onMouseOver", "onMouseUp",
			"onResize", "onReset", "onSubmit", "onAbort", "onError", "onLoad",
			"onSelectStart", "onSelect", "onChange" };

	public static final String[] JS_COLLECTIONS = { "anchors", "applets",
			"attributes", "childNodes", "embeds", "forms", "images", "links",
			"plugins", "stylesheets", "bookmarks", "boundElements", "elements",
			"plugins", "options", "cells", "rows", "tBodies", "frames" };
	
	public static final String[] JS_KEYWORDS = { "abstract", "boolean", "break", "byte",
		"case", "catch", "char", "class", "const", "continue", "debugger", "default",
		"delete", "do", "double", "else", "enum", "export", "extends", "false", "final",
		"finally", "float", "for", "function", "goto", "if", "implements", "import",
		"in", "instanceof", "int", "interface", "long", "native", "new", "null",
		"package", "private", "protected", "public", "return", "short", "static",
		"super", "switch", "synchronized", "this", "throw", "throws", "transient",
		"true", "try", "typeof", "var", "void", "volatile", "while", "with" };

} // IJavascriptConstants
