/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.rhtml;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.Token;

/**
 * Predicate rule for detected the equals sign at the end of an HTML attribute.
 * 
 * @author mkent
 * 
 */
public class EqualsRule implements IPredicateRule {

	private IToken fToken;

	public EqualsRule(IToken token) {
		fToken = token;
	}

	public IToken evaluate(ICharacterScanner scanner, boolean resume) {
		return evaluate(scanner);
	}

	public IToken getSuccessToken() {
		return fToken;
	}

	public IToken evaluate(ICharacterScanner scanner) {
		int ch = scanner.read();
		if (ch == '=') {
			return fToken;
		}
		scanner.unread();
		return Token.UNDEFINED;
	}

}
