/*******************************************************************************
 * Copyright (c) 2006 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.rhtml;

import java.util.Map;

import org.eclipse.jface.text.IDocument;
import org.radrails.rails.internal.ui.editors.CompositeTokenScanner;

/**
 * Scans and colors the partitions of an HTML attribute.
 * 
 * @author mkent
 * 
 */
public class RHTMLAttributeScanner extends CompositeTokenScanner {

	public RHTMLAttributeScanner() {
		super(RHTMLAttributePartitionScanner.getInstance());
	}

	protected Map createTokenScanners() {
		Map tokenScanners = super.createTokenScanners();

		tokenScanners.put(IDocument.DEFAULT_CONTENT_TYPE,
				new DefaultAttributeScanner());
		tokenScanners.put(RHTMLAttributePartitionScanner.RHTMLATT_EQUALS,
				new DefaultScanner());

		return tokenScanners;
	}

}
