/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.editors.rhtml;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.MultiLineRule;

/**
 * Added to take care of instances where ERB tags are inside values of HTML tags.
 * 
 * @author	mbaumbach
 * 
 * @version	0.4.1
 */
public class TagRule extends MultiLineRule {

	/**
	 * Creates a new TagRule.
	 * 
	 * @param	token	The token to use.
	 */
	public TagRule(IToken token) {
		super("<", ">", token, (char) 0, true);
	}
	
	/**
	 * @see org.eclipse.jface.text.rules.PatternRule#sequenceDetected(org.eclipse.jface.text.rules.ICharacterScanner, char[], boolean)
	 */
	protected boolean sequenceDetected(ICharacterScanner scanner,char[] sequence,boolean eofAllowed) {
		if (sequence[0] == '>') {
			scanner.unread();
			scanner.unread();
			int c = scanner.read();
			scanner.read();
			
			if(c == '%' || c == '=') {
				return false;
			}
		}
		return super.sequenceDetected(scanner, sequence, eofAllowed);
	}
	
} // TagRule