/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/
package org.radrails.rails.internal.ui.editors.yml;

import org.eclipse.jface.text.DocumentCommand;
import org.eclipse.jface.text.source.IOverviewRuler;
import org.eclipse.jface.text.source.IVerticalRuler;
import org.eclipse.jface.text.source.projection.ProjectionViewer;
import org.eclipse.swt.widgets.Composite;

/**
 * Custom source viewer for the YML editor. Replaces typed tabs with two spaces
 * (per the YML specification).
 * 
 * @author mkent
 * 
 */
public class YMLSourceViewer extends ProjectionViewer {

	public YMLSourceViewer(Composite parent, IVerticalRuler ruler,
			IOverviewRuler overviewRuler, boolean showsAnnotationOverview,
			int styles) {
		super(parent, ruler, overviewRuler, showsAnnotationOverview, styles);
	}

	protected void customizeDocumentCommand(DocumentCommand command) {
		// TODO Auto-generated method stub
		super.customizeDocumentCommand(command);

		if (command.text.equals("\t")) {
			command.text = "  ";
		}
	}

}
