/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.radrails.rails.internal.ui.RailsUIPlugin;
import org.radrails.rails.internal.ui.editors.js.IJavascriptEditorColorConstants;

public class JavascriptEditorPreferencePage extends SourceEditorPreferencePage
		implements IWorkbenchPreferencePage {

	public JavascriptEditorPreferencePage() {
		setPreferenceStore(RailsUIPlugin.getInstance().getPreferenceStore());
		setDescription("Javascript editor preferences");
	}

	protected void createFieldEditors() {
		Composite parent = getFieldEditorParent();
		parent.setLayout(new GridLayout());
		createSyntaxEditor(parent, IJavascriptEditorColorConstants.SINGLE_LINE_COMMENT,
				"Single line comment");
		createSyntaxEditor(parent, 
				IJavascriptEditorColorConstants.MULTI_LINE_COMMENT,
				"Multi line comment");
		createSyntaxEditor(parent, IJavascriptEditorColorConstants.EVENT,
				"Javascript event");
		createSyntaxEditor(parent, IJavascriptEditorColorConstants.KEYWORD,
				"Javascript keyword");
		createSyntaxEditor(parent, IJavascriptEditorColorConstants.STRING,
				"String");
		addField(new StringFieldEditor(
				IRailsPreferenceConstants.JAVASCRIPT_INDENTATION,
				"Character(s) per indentation level", 3, getFieldEditorParent()));
		addField(new BooleanFieldEditor(
				IRailsPreferenceConstants.JAVASCRIPT_FORMAT_USE_TAB, "Use Tabs",
				getFieldEditorParent()));
	}

	public void init(IWorkbench workbench) {
		// Do nothing
	}

}
