package org.radrails.rails.internal.ui.preferences;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbenchPreferencePage;

public abstract class SourceEditorPreferencePage extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {

	protected SourceEditorPreferencePage() {
		super(FLAT);
	}
	
	protected void createSyntaxEditor(Composite parent, String prefKey, String prefName) {
		Composite tokenPrefs = new Composite(parent, SWT.NULL);
		tokenPrefs.setLayout(new GridLayout(4, false));
		tokenPrefs.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Label tokenName = new Label(tokenPrefs, SWT.LEFT);
		tokenName.setText(prefName);
		tokenName.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Composite tokenColor = new Composite(tokenPrefs, SWT.NULL);
		addField(new ColorFieldEditor(prefKey, "", tokenColor));
		Composite tokenBold = new Composite(tokenPrefs, SWT.NULL);
		addField(new BooleanFieldEditor(prefKey + IRailsPreferenceConstants.BOLD_SUFFIX, "Bold", tokenBold));
		Composite tokenItalic = new Composite(tokenPrefs, SWT.NULL);
		addField(new BooleanFieldEditor(prefKey + IRailsPreferenceConstants.ITALIC_SUFFIX, "Italic", tokenItalic));
	}

}
