/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.rails.internal.ui.preferences;

import org.eclipse.jface.preference.ColorFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.radrails.rails.internal.ui.RailsUIPlugin;
import org.radrails.rails.internal.ui.editors.yml.IYMLEditorColorConstants;

/**
 * Preference page for the YML editor.
 * 
 * @author mkent
 * 
 */
public class YMLEditorPreferencePage extends FieldEditorPreferencePage
		implements IWorkbenchPreferencePage {

	/**
	 * Constructor.
	 */
	public YMLEditorPreferencePage() {
		super(GRID);

		setPreferenceStore(RailsUIPlugin.getInstance().getPreferenceStore());
		setDescription("YML editor preferences");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	protected void createFieldEditors() {
		addField(new ColorFieldEditor(IYMLEditorColorConstants.STRING,
				"String", getFieldEditorParent()));
		addField(new ColorFieldEditor(IYMLEditorColorConstants.NODE_NAME,
				"Node name", getFieldEditorParent()));
		addField(new ColorFieldEditor(IYMLEditorColorConstants.MAPPING_KEY,
				"Mapping key", getFieldEditorParent()));
		addField(new ColorFieldEditor(IYMLEditorColorConstants.YML_COMMENT,
				"Comment", getFieldEditorParent()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
		// Do nothing
	}
}
