/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.server.internal.ui;

import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;
import org.radrails.server.core.ServerManager;

/**
 * Plugin class for the server UI plugin.
 * 
 * @author mkent
 * 
 */
public class ServerUIPlugin extends AbstractUIPlugin {

	private static ServerUIPlugin instance;

	/**
	 * Constructor.
	 */
	public ServerUIPlugin() {
		super();
		instance = this;
	}

	/**
	 * @return the singleton instance of this class
	 */
	public static ServerUIPlugin getInstance() {
		return instance;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) {
		ServerManager.getInstance().stopAll();
	}

}
