/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/

package org.radrails.server.internal.ui.console;

import org.eclipse.jface.action.Action;
import org.radrails.rails.internal.ui.ActionUtil;
import org.radrails.server.core.ServerConsoleManager;

/**
 * Remove action for the ServerConsole.
 * 
 * @author Kyle
 * 
 */
public class ServerRemoveAction extends Action {

	/**
	 * Constructor. Initializes the action with icon and tooltip.
	 */
	public ServerRemoveAction() {
		ActionUtil.initAction(this, "removeall.gif",
				"Remove all terminated server consoles");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		ServerConsoleManager.getInstance().removeTerminatedConsoles();
	}
}
