/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/
package org.radrails.server.internal.ui.console;

import java.util.Observable;
import java.util.Observer;

import org.eclipse.jface.action.Action;
import org.radrails.server.core.IServerConstants;
import org.radrails.server.core.Server;
import org.radrails.server.core.ServerConsole;
import org.radrails.server.core.ServerManager;
import org.radrails.server.internal.ui.ActionUtil;

/**
 * Stop action for ServerConsole.
 * 
 * @author Kyle
 * 
 */
public class ServerStopAction extends Action implements Observer {

	private ServerConsole console;

	/**
	 * Constructor. Initializes action with icon and tooltip.
	 * 
	 * @param console
	 */
	public ServerStopAction(ServerConsole console) {
		this.console = console;
		ActionUtil.initAction(this, "stop.gif", "Stop server");
		ServerManager.getInstance().addServerObserver(this);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		console.stopServer();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
	 */
	public void update(Observable o, Object arg) {
		String action = (String) arg;
		if (action.equals(IServerConstants.UPDATE)) {
			Server s = (Server) o;
			if (s.isStopped() || s.isStopping() ) {
				setEnabled(false);
			}
		}
	}
}
