/*******************************************************************************
 * Copyright (c) 2005 RadRails.org and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.radrails.org/legal/cpl-v10.html
 *******************************************************************************/
package org.radrails.server.internal.ui.wizards;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.radrails.rails.ui.wizards.NewProjectBasedResourceWizard;
import org.radrails.server.core.Server;
import org.radrails.server.core.ServerManager;
import org.radrails.server.core.lighttpd.LightTPDServer;
import org.radrails.server.internal.ui.ServerUIPlugin;
import org.radrails.server.internal.ui.wizards.pages.WizardNewLightTPDServerPage;

/**
 * Wizard to create a new LightTPD server.
 * 
 * @author mkent
 * 
 */
public class NewLightTPDServerWizard extends NewProjectBasedResourceWizard {

	WizardNewLightTPDServerPage page1;

	/**
	 * Constructor.
	 */
	public NewLightTPDServerWizard() {
		setWindowTitle("New LightTPD Server");
	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#performFinish()
	 */
	public boolean performFinish() {
		Server s = new LightTPDServer(getProjectForName(page1.getProjectName())
				.getLocation().toFile(), page1.getServerName(), page1.getPort());
		ServerManager.getInstance().addServer(s);

		return true;
	}

	/**
	 * @see org.eclipse.jface.wizard.IWizard#addPages()
	 */
	public void addPages() {
		ImageDescriptor image = AbstractUIPlugin.imageDescriptorFromPlugin(
				ServerUIPlugin.getInstance().getBundle().getSymbolicName(),
				"icons/lighttpd.gif");

		page1 = new WizardNewLightTPDServerPage("page1");
		page1.setImageDescriptor(image);

		addPage(page1);
	}

}
